package org.waikato.harvest;

import java.io.File;
import java.io.FileInputStream;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.Reader;
import java.util.ArrayList;

import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;
import org.xml.sax.Attributes;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;
import org.xml.sax.helpers.DefaultHandler;


public class OAIListSAXHandler extends DefaultHandler
{
    boolean identifier_tag_open_ = false;
    String  identifier_text_     = null;
    
    boolean resumptionToken_tag_open_ = false;
    String  resumptionToken_text_     = null;

    ArrayList<String> identifiers_;

    public OAIListSAXHandler()
    {
	identifiers_ = new ArrayList<String>();
    }
    
    public void startElement(String uri, String localName,
			     String qName, Attributes attributes) throws SAXException
    {		
	if (qName.equalsIgnoreCase("identifier")) {
	    identifier_tag_open_ = true;
	}
	else if (qName.equalsIgnoreCase("resumptionToken")) {
	    resumptionToken_tag_open_ = true;
	}
    }
	
    public void characters(char ch[], int start, int length) throws SAXException
    {
	if (identifier_tag_open_) {
	    identifier_text_ = new String(ch, start, length);
	}
	else if (resumptionToken_tag_open_) {
	    resumptionToken_text_ = new String(ch, start, length);
	}
	
    }
	
    public void endElement(String uri, String localName, String qName) throws SAXException
    {
	if (qName.equalsIgnoreCase("identifier")) {
	    identifiers_.add(identifier_text_);
	    identifier_text_ = null;
	    identifier_tag_open_ = false;
	}
	else if (qName.equalsIgnoreCase("resumptionToken")) {
	    resumptionToken_tag_open_ = false;
	}
	
    }

    public void printIdentifiers()
    {
	for (String id: identifiers_) {
	    System.out.println("id: " + id);
	}

	System.out.println("Resumption token: " + resumptionToken_text_);
    }

    public ArrayList<String> getIdentifiers()
    {
	return identifiers_;
    }

    public String getResumptionToken()
    {
	return resumptionToken_text_;
    }
}

